
; --------------------------------------------
; "finder" - by #NULL
; little tool for using search sites in 
; the internet more straight.
; the window will hide at your desktop's 
; top edge.
; --------------------------------------------

Procedure valHex(string.s) ;v1.0
  Protected ret.l
  Protected len.l = Len(string)
  Protected i.l
  Protected char
  Protected signif.l
  For i=0 To len-1 :;Debug Mid(string,len-i,1)
    char = Asc(UCase(Mid(string,len-i,1)))
    If (char>=48 And char<=57)
      char = char-48
    ElseIf (char>=65 And char<=70)
      char = char-65 + 10
    Else
      ;++++++++
      Continue
      ;++++++++
    EndIf
    ret | (char<<(4*(signif)))
    signif+1
  Next
  ProcedureReturn ret
EndProcedure


Macro getNextLineFromFile()
  line.s=ReadString(0)
  While Not line And Not Eof(0)
    line=ReadString(0)
  Wend
EndMacro


Enumeration 
  #win_fake
  #win
  ; ---footer:
  #f3d; frame3dgadet
  #tg ; textgadget
  #tg2; textgadget
  #sg ; stringgadget
  #bq ; button (quit)
  ; ---
  #return ; menu returnkey / enterkey (keyboard)
EndEnumeration


Structure elementS
  first.s  ; URL-part before search-term
  second.s ; URL-part following the search-term
  b1.l     ; button ID
  s1.l     ; string-gadget ID
EndStructure
NewList element.elementS()


Declare add(name.s, url.s)
Declare runBrowser( *p.elementS, search.s)




ExamineDesktops()
ww=300        ; windowwidth
wh=2          ; windowheight
wy=0          ; window y-pos (used for roll-effect)
wx=(DesktopWidth(0)-ww)/2 ; window x-pos
count.l=0
barcolor=$00ff00


;style|#PB_Window_SizeGadget
style|#PB_Window_BorderLess
hWinFake=OpenWindow(#win_fake,0,0,100,100,"fake",#PB_Window_Invisible) ;just a parent fake, to avoid taskbar entry
hWin=OpenWindow(#win, 0,0, 0,0, "finder",style, hWinFake)
CreateGadgetList(hWin)


If Not GetPathPart(ProgramFilename()) = #PB_Compiler_Home+"Compilers\"
  SetCurrentDirectory(GetPathPart(ProgramFilename()))
EndIf

inifile.s="finder.ini"
If Not ReadFile(0,inifile)
  MessageRequester("error", "can't find file"+#CRLF$+inifile)
  End
Else
  getNextLineFromFile() :: browser$ =StringField(line,2,"=")
  getNextLineFromFile() :: wildcard$=StringField(line,2,"=")
  getNextLineFromFile() :: barcolor =valHex(StringField(StringField(line,2,"="),1,";"))
  If Not (browser$ And wildcard$)
    MessageRequester("error", "invalid format in"+#CRLF$+inifile)
    End
  Else
    While Not Eof(0)
      getNextLineFromFile() :: name.s=line
      getNextLineFromFile() :: url.s =line
      If name And url
        add(name, url)
      EndIf
    Wend
  EndIf
  CloseFile(0)
EndIf

; ---footer:
wh+100
Frame3DGadget(#f3d,  8,   count*50+12,    ww-16,       80, "clipboard preview")
;TextGadget(  #tg2, 16,   count*50+16,    ww-70-16-8,  20, "preview:", 0*#PB_Text_Border)
StringGadget( #sg,  16, 28+count*50,     ww-16-16,  20, GetClipboardText())
TextGadget(   #tg,  16, 28+28+count*50, ww-70-16-20,  30, "  use clipboard text (zack) or"+#CRLF$+"  type something and press return.", 0*#PB_Text_Border)
ButtonGadget( #bq,  ww-70-16, wh-20-16,   70,          20, "quit")
; ---


ResizeWindow(#win, wx,wy, ww,wh)
StickyWindow(#win,1)
AddKeyboardShortcut(#win, #PB_Shortcut_Return, #return)


;now roll up
For wy=0 To -wh+2 Step -60
  ResizeWindow(#win, #PB_Ignore,wy, #PB_Ignore,#PB_Ignore):::While WindowEvent():Wend
  Delay(1)
Next
SetWindowColor(#win,barcolor)
wy=-wh+2:::ResizeWindow(#win, #PB_Ignore,wy, #PB_Ignore,#PB_Ignore):::While WindowEvent():Wend





;############ MAIN ############
Repeat
  event=WaitWindowEvent(80)
  eg=EventGadget()
  em=EventMenu()
  et=EventType()
  
  ;show window (roll down)
  If WindowMouseX(#win) > -1 And Not show
    show=1
    SetWindowColor(#win,-1)
    SetGadgetText(#sg,GetClipboardText())
    For wy=-wh To 0 Step 60
      ResizeWindow(#win, #PB_Ignore,wy, #PB_Ignore,#PB_Ignore):::While WindowEvent():Wend
      Delay(1)
    Next
    wy=0:::ResizeWindow(#win, #PB_Ignore,wy, #PB_Ignore,#PB_Ignore):::While WindowEvent():Wend
  EndIf
  
  ;hide window (roll up)
  If WindowMouseX(#win) = -1 And show
    show=0
    For wy=0 To -wh+2 Step -60
      ResizeWindow(#win, #PB_Ignore,wy, #PB_Ignore,#PB_Ignore):::While WindowEvent():Wend
      Delay(1)
    Next
    SetWindowColor(#win,barcolor)
    wy=-wh+2:::ResizeWindow(#win, #PB_Ignore,wy, #PB_Ignore,#PB_Ignore):::While WindowEvent():Wend
  EndIf
  
  Select event
    Case #PB_Event_CloseWindow
      quit=1
    Case #PB_Event_Gadget
      Select eg
        Case #bq
          quit=1
        Default
          ForEach element()
            Select eg
              Case element()\b1
                runBrowser( element(), GetClipboardText() )
            EndSelect
          Next
      EndSelect
    Case #PB_Event_Menu
      If em=#return
        ForEach element()
          If element()\s1=GetActiveGadget()
            runBrowser( element(), GetGadgetText(element()\s1) )
          EndIf
        Next
      EndIf
    ;++++++++++
    CompilerIf #PB_Compiler_OS = #PB_OS_Windows
    ;++
    Case #WM_LBUTTONDOWN
      SendMessage_(hWin, #WM_NCLBUTTONDOWN, #HTCAPTION, 0)
    ;++
    CompilerEndIf
    ;++++++++++
    Default
      If et = #PB_EventType_LeftClick
        Debug eg
        Debug ""
      EndIf
  EndSelect
Until quit
;########## MAIN end ##########







Procedure add(name.s, url.s)
  ; defines and initializes an
  ; URL element And creates the
  ; corresponding gadgets
  Shared count, element(), ww, wh, wildcard$
  Protected pos.l
  AddElement(element())
  pos=FindString(url, wildcard$, 1)
  element()\first.s=Left(url, pos-1)
  element()\second.s=Right(url, Len(url)-pos-3)
  Frame3DGadget(            #PB_Any, 8,   2+count*50,     ww-16,              45, name.s)
  element()\b1=ButtonGadget(#PB_Any, 16, 18+count*50,     50,                 20, "zack!!")
  element()\s1=StringGadget(#PB_Any, 70, 18+count*50,     ww-16-50-16-4,  20, "")
  count+1
  wh+50
EndProcedure


Procedure runBrowser( *p.elementS, search.s)
  If Len(search)>256
    If MessageRequester("confirm..","the seach string is very long (>256) !"+#CRLF$+"use it anyway ?", #PB_MessageRequester_YesNo)  =  #PB_MessageRequester_No
      ProcedureReturn
    EndIf
  EndIf
  Shared wh, wy, browser$
  Protected param.s
  search=ReplaceString(search, " ", "%20")
  param= Chr(34) +*p\first +search + *p\second +Chr(34)
  If Not RunProgram(browser$, param, "")
    MessageRequester("error", "can't run browser"+#CRLF$+browser$)
  EndIf
  
  show=0
  wy=-wh+2
  ResizeWindow(#win, #PB_Ignore,wy, #PB_Ignore,#PB_Ignore)
  While WindowEvent() : Wend
EndProcedure





; IDE Options = PureBasic 4.10 Beta 4 (Windows - x86)
; CursorPosition = 41
; Folding = -
; EnableXP
; UseIcon = finder.ico
; Executable = finder.exe
; CompileSourceDirectory